% This files derives the LQR controller for the two link pendulum in
% assignment 2
T = 0.01;  % time step
M = 0.5;     % mass (same for both masses)
L = 1/2;   % distance from joint to center of mass (also same)
G = 9.81;  % gravity
I = 0.334167;   % moment of inertia from ODE program (also same)
F = 0.1;        % viscous friction

syms a1 a2 ad1 ad2 add1 add2 t1 t2

MM = [ M*L*L/4+I+M*L*L+M*L*L+M*L*L*cos(a2)+I M*L*L/4+M*L*L*cos(a2)/2+I;
      M*L*L/4+M*L*L*cos(a2)/2+I               M*L*L/4+I ]
C = [ -M*L*L*sin(a2)*ad1*ad2-M*L*L*sin(a2)*ad2*ad2/2;
      M*L*L*sin(a2)*ad1*ad1/2 ]
G = [ M*G*L*sin(a1)/2+M*G*L*sin(a1)+M*G*L*sin(a1+a2)/2;
      M*G*L*sin(a1+a2)/2 ]
  
addMat = inv(MM)*([t1;t2]-F*[ad1;ad2]-C-G);

q0 = simplify(diff(addMat,a1));
q1 = simplify(diff(addMat,a2));
q2 = simplify(diff(addMat,ad1));
q3 = simplify(diff(addMat,ad2));
q4 = simplify(diff(addMat,t1));
q5 = simplify(diff(addMat,t2));

a1 = pi;
a2 = 0;
ad1 = 0;
ad2 = 0;
t1 = 0;
t2 = 0;

%subs(q0)
%subs(q1)
%subs(q2)
%subs(q3)
%subs(q4)
%subs(q5)

% linearization
a = [ 0 0 1 0
      0 0 0 1
      subs(q0) subs(q1) subs(q2) subs(q3) ]

%a = [ 1 T
% M*G*L*T/I  1 - (F*T)/I ]

%b = [ 0 0
%      0 0
%      subs(q4) subs(q5) ]
t4 = subs(q4);
t5 = subs(q5);
%t4 = [0;0];
b = [ 0 0
      0 0
      t4(1) t5(1)
      t4(2) t5(2) ];

%b = [ 0

% elements of one step cost function
%q = [1 0 0 0
%     0 1 0 0
%     0 0 1 0
%     0 0 0 1];

q = [ 0.1*T 0   0   0
       0    0.1*T   0   0
       0    0   0 0
       0    0   0   0 ]
    
%q = [ 0.1*T 0
%      0     0 ]

%r = [1 0
%     0 1];

r = [ T 0
     0 T ]

 %r = [ T ]

[k,s,e] = lqrd(a,b,q,r,T)
