%this script will load the trajectory produced by use-policy
load traj

figure(1)
subplot(2,2,1)
plot(traj(:,1),traj(:,2))
xlabel('time (seconds)')
ylabel('\theta_1');
hold on;
plot([10],[pi],'r^')
%legend('trajectory','goal');

subplot(2,2,2)
plot(traj(:,1),traj(:,3))
xlabel('time (seconds)')
ylabel('\theta_2');
hold on;
plot([10],[0],'r^');

subplot(2,2,3)
plot(traj(:,1),traj(:,4))
xlabel('time (seconds)')
ylabel('\omega_1');
hold on;
plot([10],[0],'r^');

subplot(2,2,4)
plot(traj(:,1),traj(:,5))
xlabel('time (seconds)')
ylabel('\omega_2');
hold on;
plot([10],[0],'r^');

print(gcf,'-dpng','state_over_time.png');

figure(2)
subplot(3,1,1)
plot(traj(:,1),traj(:,6))
ylabel('\tau_1');
xlabel('time');
title('torque_1 versus time');

subplot(3,1,2)
plot(traj(:,1),traj(:,7))
ylabel('\tau_2');
xlabel('time');
title('torque_2 versus time');

subplot(3,1,3)
plot(traj(:,1),traj(:,8))
final_score = traj(size(traj,1),8);
title(sprintf('Score versus time: Final Score=%f',final_score));

print(gcf,'-dpng','action_over_time.png');

goal = [pi 0 0 0];
for i = 1:size(traj,1)
  d(i) = norm(goal - traj(i,2:5));
end

figure(3)
plot(traj(:,1),d)
title('euclidean distance from current state to goal state');
xlabel('time (seconds)')
ylabel('distance')
print(gcf,'-dpng','distance_over_time.png');
